use fbrfinal.dta

***asinh tip regressions
*naive robust
reg ihs_tip X tc, absorb(FEs) robust
nlcom _b[X]*xbar*((sqrt(tipbar^2)+1)/tipbar)

*naive cluster
reg ihs_tip X tc, absorb(FEs) cluster(FEs)
nlcom _b[X]*xbar*((sqrt(tipbar^2)+1)/tipbar)

*fdc stage 1
reg M X tc, absorb(FEs)
est store st1

*fdc stage 2 
reg ihs_tip M X tc, absorb(FEs)
est store st2

*fdc robust
suest st1 st2, vce(robust)
nlcom [st1_mean]_b[X]*[st2_mean]_b[M]
nlcom ([st1_mean]_b[X]*[st2_mean]_b[M])*xbar*((sqrt(tipbar^2)+1)/tipbar)

*fdc cluster
suest st1 st2, vce(cluster FEs)
nlcom [st1_mean]_b[X]*[st2_mean]_b[M]
nlcom ([st1_mean]_b[X]*[st2_mean]_b[M])*xbar*((sqrt(tipbar^2)+1)/tipbar)


***tipped regressions
*naive robust
reg tipped X tc, absorb(FEs) robust 
nlcom _b[X]*(xbar/tippedbar)

*naive cluster
reg tipped X tc, absorb(FEs) cluster(FEs)
nlcom _b[X]*(xbar/tippedbar)

*fdc stage 1 
reg M X tc, absorb(FEs)
est store st1

*fdc stage2 
reg tipped M X tc, absorb(FEs)
est store st2

*fdc robust
suest st1 st2, vce(robust)
nlcom [st1_mean]_b[X]*[st2_mean]_b[M]
nlcom ([st1_mean]_b[X]*[st2_mean]_b[M]*(xbar/tippedbar))

*fdc cluster
suest st1 st2, vce(cluster FEs)
nlcom [st1_mean]_b[X]*[st2_mean]_b[M]
nlcom ([st1_mean]_b[X]*[st2_mean]_b[M]*(xbar/tippedbar))

***asinh tip/price
*naive robust
reg ihs_tipperc X tc, absorb(FEs) robust
nlcom _b[X]*xbar*((sqrt(tippercbar^2)+1)/tippercbar)

*naive cluster
reg ihs_tipperc X tc, absorb(FEs) cluster(FEs)
nlcom _b[X]*xbar*((sqrt(tippercbar^2)+1)/tippercbar)

*stage 1
reg M X tc, absorb(FEs)
est store st1

*stage 2 
reg ihs_tipperc M X tc, absorb(FEs)
est store st2

*fdc robust
suest st1 st2, vce(robust)
nlcom [st1_mean]_b[X]*[st2_mean]_b[M]
nlcom ([st1_mean]_b[X]*[st2_mean]_b[M])*xbar*((sqrt(tippercbar^2)+1)/tippercbar)

*fdc cluster
suest st1 st2, vce(cluster FEs)
nlcom [st1_mean]_b[X]*[st2_mean]_b[M]
nlcom ([st1_mean]_b[X]*[st2_mean]_b[M])*xbar*((sqrt(tippercbar^2)+1)/tippercbar)

